/* Edit this variable to add/remove options for squares */
let contents = [
    "“Happily Ever After” epilogue",
    "Campaign fork",
    "Protagonist makes bad judgment calls",
    "Male mentor side character",
    "Female side character who is royalty or equivalent ranking",
    "Low health enemy survives attacks from 4 units at once",
    "Enemy leader is invincible",
    "Loyal magic unit",
    "Loyal unit obtained via village",
    "Evil saurian who likes money as enemy",
    "Enemy infighting",
    "Enemy is orcs, bandits or undead",
    "Elves get mad because you entered forest",
    "Allies are elves or dwarves",
    "Monsters side with enemy",
    "Enemy is attacking because of gold",
    "Enemy lands every hit without being hit",
    "Magic attack misses all times",
    "Enemy is attacking just because they are evil",
    "Going into unfamiliar area to get ally",
    "Dialogue has accent for some characters",
    "Custom campaign units",
    "Giant scorpions, giant spiders etc.",
    "Campaign artifact",
    "There is a scenario where you cannot recruit",
    "You get separated from your army",
    "There is a “Survive for X turns” scenario",
    "One of your protagonists disappears on one scenario",
    "There is a story text screen without an image",
    "You get a free healer unit",
    "Cave scenario",
    "Unit who is about to level up is killed"
    //Add extra options for the squares here
];

let backgroundColor = "background-color: rgb(160,90,255)";
let squares = document.querySelectorAll(".space");

function formatFreeSpace() {
    let centerSpace = document.querySelector("#center-space");
    let par0 = document.createElement("p");
    par0.textContent = "Has a protagonist";
    centerSpace.replaceChildren(par0);
    let hr = document.createElement("hr");
    centerSpace.appendChild(hr);
    let par1 = document.createElement("p");
    par1.textContent = "FREE SPACE";
    centerSpace.appendChild(par1);
    centerSpace.style = backgroundColor;
}

/* fill the grid */
var selected = [];
function fillGrid(savedGridContent, savedGridToggles) {
    squares = document.querySelectorAll(".space");
    selected = [];
    if (savedGridContent != null) {
        for (i = 0; i < savedGridContent.length && i < 24; i++) {
            let candidate = contents[savedGridContent[i]];
            if (selected.indexOf(candidate) == -1) {
                selected.push(candidate);
            }
        }
    }

    /*
    if the savedGrid had repeats, fill in the rest of the grid
      OR
    if there is no savedGrid, populate the grid
    */
    while (selected.length < 24) {
        let index = Math.floor(Math.random() * contents.length);
        let candidate = contents[index];
        if (selected.indexOf(candidate) == -1) {
            selected.push(candidate);
        }
    }

    if (squares.length !== selected.length) {
        throw Error("Available squares and selected elements do not match");
    }

    for (let i = 0; i < squares.length; i++) {

        let par2 = document.createElement("p");
        par2.textContent = selected[i];
        squares[i].replaceChildren(par2);
        if (savedGridToggles != null && savedGridToggles.length == 24) {
            let isToggled = savedGridToggles[i] === '1';
            squares[i].setAttribute("toggled", isToggled);
            if (isToggled) {
                squares[i].style = backgroundColor;
            }
            else {
                squares[i].style = "background-color: white";
            }
        }
        else {
            squares[i].setAttribute("toggled", false); // this automatically casts to a string...
            squares[i].style = "background-color: white";
        }

    }
}

//Separated this out from fillGrid() to not accidentally add multiple eventListeners
function addEventListening() {
    // allow clicking
    for (let i = 0; i < 24; i++) {
        squares[i].addEventListener("click", (ev) => {
            if (squares[i].getAttribute("toggled") === "true") {
                squares[i].style = "background-color: white";
                squares[i].setAttribute("toggled", false);
            }
            else {
                squares[i].style = backgroundColor;
                squares[i].setAttribute("toggled", true);
            }
        });
    }
}

/*
  save file format:
  content indices separated by commas,
  percent sign (%),
  toggle values (booleans) separated by commas
*/
function saveGrid() {
    let content = [];
    let toggle = [];
    for (let i = 0; i < 24; i++) {
        content.push(contents.indexOf(squares[i].firstChild.textContent));
        let isToggled = squares[i].getAttribute("toggled") === "true";
        if (isToggled) {
            toggle.push(1);
        }
        else {
            toggle.push(0);
        }
    }

    let outputSave = document.getElementById("saveBingoCard");
    outputSave.value = content + "%" + toggle;
}

function loadGrid() {
    let input = document.getElementById("loadBingoCard").value;
    let lines = input.split("%");
    if (lines.length != 2) {
        throw Error("Incorrect Format");
    }

    let content = lines[0].split(",");
    let toggle = lines[1].split(",");

    fillGrid(content, toggle);
}

function startBingo() {
    formatFreeSpace();
    fillGrid();
    addEventListening();
}

startBingo();